//
//  StartappBanner.m
//  Pods-Runner
//
//  Created by Phan Luân on 3/18/20.
//

#import "StartappBannerController.h"

@interface StartappBanner : NSObject<FlutterPlatformView>
-(instancetype)initWithWithFrame:(CGRect)frame
                  viewIdentifier:(int64_t)viewId
                       arguments:(id)args
                 binaryMessenger:(NSObject<FlutterBinaryMessenger>*)messenger;
- (STABannerView*)view;
@end

@implementation StartappBanner {
  int64_t _viewId;
  FlutterMethodChannel* _channel;
  STABannerView* bannerView;
}

- (instancetype)initWithWithFrame:(CGRect)frame
                   viewIdentifier:(int64_t)viewId
                        arguments:(id)args
                  binaryMessenger:(NSObject<FlutterBinaryMessenger>*)messenger {
      _viewId = viewId;
      NSString* channelName = [NSString stringWithFormat:@"startapp/banner_%lld", viewId];
      bannerView = [[STABannerView alloc] initWithSize:STA_PortraitAdSize_320x50 autoOrigin:STAAdOrigin_Bottom
                                            withDelegate:self];
      [bannerView loadAd];
      _channel = [FlutterMethodChannel methodChannelWithName:channelName binaryMessenger:messenger];
  return self;
}

- (void) bannerAdIsReadyToDisplay:(STABannerView*)banner {
    bannerView = bannerView;
    NSLog(@"Event log: bannerAdIsReadyToDisplay" );
}

- (void) didDisplayBannerAd:(STABannerView*)banner {
    bannerView = bannerView;
    NSLog(@"Event log: didDisplayBannerAd" );
    [_channel invokeMethod:@"onReceiveAd" arguments:(nil) ];
}

- (void) failedLoadBannerAd:(STABannerView*)banner withError:(NSError *)error {
    bannerView = bannerView;
    NSLog(@"Event log: failedLoadBannerAd" );
    [_channel invokeMethod:@"onFailedToReceiveAd" arguments:(nil) ];
}
- (void) didClickBannerAd:(STABannerView*)banner {
    bannerView = bannerView;
    NSLog(@"Event log: didClickBannerAd" );
    [_channel invokeMethod:@"onClick" arguments:(nil) ];
}
- (void) didCloseBannerInAppStore:(STABannerView*)banner {
    bannerView = bannerView;
    NSLog(@"Event log: didCloseBannerInAppStore" );
    [_channel invokeMethod:@"onClose" arguments:(nil) ];
}

- (STABannerView*)view {
  return bannerView;
}

@end
