//
//  StartappBannerFactory.m
//  Pods
//
//  Created by Phan Luân on 3/18/20.
//
#import "StartappBanner.m"

NS_ASSUME_NONNULL_BEGIN

@interface StartappBannerFactory : NSObject<FlutterPlatformViewFactory>
- (instancetype)initWithMessenger:(NSObject<FlutterBinaryMessenger>*)messager;
@end

NS_ASSUME_NONNULL_END

@implementation StartappBannerFactory

{
    NSObject<FlutterBinaryMessenger>*_messenger;
}

- (instancetype )initWithMessenger:(NSObject<FlutterBinaryMessenger> *)messager{
    self = [super init];
    if (self) {
        _messenger = messager;
    }
    return self;
}

-(NSObject<FlutterMessageCodec>*)createArgsCodec {
   return [FlutterStandardMessageCodec sharedInstance];
}

- (NSObject<FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id)args {
    StartappBanner *webView = [[StartappBanner alloc] initWithWithFrame:frame viewIdentifier:viewId arguments:args binaryMessenger:_messenger];
    return webView;
}

@end
