#import "StartappPlugin.h"
#import "StartappBannerFactory.m"

@implementation StartappPlugin

NSString *pluginKey = @"startapp/banner";

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"startapp"
            binaryMessenger:[registrar messenger]];
  StartappPlugin* instance = [[StartappPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
  [registrar registerViewFactory: [[StartappBannerFactory alloc] initWithMessenger:registrar.messenger] withId: pluginKey];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if ([@"initialize" isEqualToString:call.method]) {
        NSString *appId = call.arguments[@"appId"];
        STAStartAppSDK* sdk = [STAStartAppSDK sharedInstance];
        sdk.appID = appId;

        result([NSNumber numberWithBool:YES]);
    } else {
       result(FlutterMethodNotImplemented);
    }
}

@end
